<template>
  <div>
    <Modal v-model="showEditModal" v-drag :mask-closable="true" width="1000px">
      <p slot="header">
        {{ modalTitle }}
      </p>
      <div>
        <Form
          id="edit-form-train-record-edit"
          ref="formObj"
          :model="formObj"
          :rules="ruleValidate"
          :label-width="80"
        >
          <Form-item label="计划名称" prop="name">
            <Tooltip content="字符长度0-100" placement="bottom-start">
              <Input
                v-model="formObj.name"
                name="name"
                placeholder="请输入计划名称"
                :maxlength="100"
                style="width: 478px;"
              ></Input>
            </Tooltip>
          </Form-item>
          <Form-item label="编制人" prop="maker">
            <Input
              v-model="formObj.maker"
              name="maker"
              placeholder="请选择编制人"
              icon="plus-circled"
              readonly
              @on-click="_selectApply"
            ></Input>
            <input v-model="formObj.makerId" name="makerId" type="hidden">
          </Form-item>
          <Form-item label="编制日期" prop="makeDate">
            <Date-picker
              v-model="formObj.makeDate"
              name="makeDate"
              type="date"
              placeholder="请选择编制日期"
              format="yyyy-MM-dd"
              style="width: 100%;"
              @on-change="_compilateDateChange"
            />
            <input name="makeDate" type="hidden">
          </Form-item>
          <Form-item label="备注" prop="remark">
            <Tooltip content="字符长度0-100" placement="bottom-start">
              <Input
                v-model="formObj.remark"
                name="remark"
                type="textarea"
                placeholder="请输入备注"
                :maxlength="100"
                style="width: 478px;"
              ></Input>
            </Tooltip>
          </Form-item>
        </Form>
      </div>
      <div slot="footer">
        <modal-footer ref="footerModal" :footer="footerList" @on-result-change="_footerResult" />
      </div>
    </Modal>

    <!--选择人员-->
    <UserInfo ref="userModal" is-change @on-result-change="_userData" />
  </div>
</template>
<script>
/**
 * 添加编辑
 */
import { dict, staffInfo, abilityMainCheck } from '../../../api'
import global from '../../../api/config'
import UserInfo from '../../../components/user-info-single/assignPerson'
export default {
  components: { UserInfo },
  data: function() {
    return {
      id: '',
      modalTitle: '添加',
      formObj: {
        name: undefined,
        remark: undefined,
        maker: undefined,
        makerId: undefined,
        makeDate: undefined,
        fileList: []
      },
      innerAuditList: [],
      userList: [],
      ruleValidate: {
        name: [{ required: true, message: '计划名称不能为空', trigger: 'blur' }]
      },
      showEditModal: false,
      footerList: [
        { id: '', name: '取消', type: '' },
        { id: '', name: '确定', type: 'primary' }
      ]
    }
  },
  methods: {
    // modal
    _footerResult(name) {
      switch (name) {
        case '取消':
          this._cancel()
          break
        case '确定':
          this._ok()
          break
      }
    },
    _hideLoading() {
      this.$refs.footerModal._hideLoading()
    },
    _resultChange(result, msg) {
      if (result) {
        this.showEditModal = false
        this.$Message.success(msg)
        this.$emit('on-result-change')
      }
      this._hideLoading()
    },
    _userData(data, msg) {
      // 选择人员返回数据
      if (msg === 'applyName') {
        // 选择取样人取样人
        this.formObj.maker = data.realname
        this.formObj.makerId = data.userId
      }
    },
    _getInnerAuditList: async function() {
      const result = await dict.getItem('内审审核类型')
      this.innerAuditList = result
    },
    _selectPlan() {
      this.$refs.trainPlanModal._open()
    },
    _compilateDateChange(data) {
      this.formObj.makeDate = data
    },
    _backTrainPlanData(data) {
      this.formObj.trainPlan = data.name
      this.formObj.trainId = data.id
    },
    _ok() {
      this.$refs.formObj.validate(valid => {
        if (valid) {
          this._save(this.formObj)
        } else {
          this.$Message.error('表单验证失败')
          this._hideLoading()
        }
      })
    },
    // 添加、编辑保存
    _save: async function(data) {
      if (data.id === undefined || data.id === '') {
        const result = await abilityMainCheck.add(data)
        this._resultChange(result, '添加成功')
      } else {
        const result = await abilityMainCheck.edit({ id: data.id, obj: data })
        this._resultChange(result, '编辑成功')
      }
    },
    _cancel() {
      this.showEditModal = false
    },
    _getUserList: async function() {
      const result = await staffInfo.list({ status: 1 })
      if (result) {
        this.userList = result
      }
    },
    _leaderChange(obj) {
      console.log(obj)
      if (obj) {
        this.formObj.checkGroupLeaderName = obj.label.trim()
      } else {
        this.formObj.checkGroupLeaderName = ''
      }
    },

    _selectApply() {
      this.$refs.userModal._open('applyName')
    },
    _memberChange(obj) {
      let names = ''
      let ids = ''
      obj.forEach(function(item) {
        names = names + item.label.trim() + ','
        ids = ids + item.value + ','
      })
      this.formObj.checkGroupMemberNames = names.substring(0, names.length - 1)
      this.formObj.checkGroupMemberIds = ids.substring(0, ids.length - 1)
    },
    _open(formObj) {
      const user = global.getUserInfo()
      console.log('----user-----', user)
      this.$refs.formObj.resetFields()
      this.formObj.makerId = user.id
      this.formObj.maker = user.realname
      this.showEditModal = true
      this._hideLoading()
      if (this.$string(formObj).isEmpty()) {
        this.id = ''
        this.modalTitle = '添加计划'
      } else {
        this.id = formObj.id
        this.formObj = formObj
        this.modalTitle = '编辑计划'
        if (undefined !== formObj.makeDate) {
          this.formObj.makeDate = this.$dateformat(
            new Date(formObj.makeDate),
            'yyyy-mm-dd'
          )
        } else {
          this.formObj.makeDate = ''
        }
        this.formObj.ctime = undefined
      }
    }
  }
}
</script>
